=== renamed directory 'bzr-plugins' => 'bzrplugins'
=== renamed symlink 'bzr-plugins/bzrloom' => 'bzrplugins/loom'
=== modified file 'bzrplugins/lpserve.py'
--- bzr-plugins/lpserve.py	2008-01-21 00:24:12 +0000
+++ bzrplugins/lpserve.py	2008-01-21 05:44:15 +0000
@@ -10,18 +10,20 @@
 __all__ = ['cmd_launchpad_server']
 
 
+import os
 import sys
 import xmlrpclib
 
 from bzrlib.commands import Command, register_command
 from bzrlib.option import Option
 from bzrlib import urlutils, ui
+from bzrlib import trace
 
+from bzrlib import plugin
 from bzrlib.smart import medium, server
 from bzrlib.transport import chroot, get_transport, remote
 
 from canonical.config import config
-from canonical.codehosting import transport
 
 
 class cmd_launchpad_server(Command):
@@ -72,6 +74,7 @@
         :return: A `LaunchpadTransport`.
         """
         # XXX: JonathanLange 2007-05-29: The 'chroot' lines lack unit tests.
+        from canonical.codehosting import transport
         hosted_transport = self._get_chrooted_transport(hosted_url)
         mirror_transport = self._get_chrooted_transport(mirror_url)
         lp_server = transport.LaunchpadServer(
@@ -112,6 +115,21 @@
 
     def run(self, user_id, port=None, upload_directory=None,
             mirror_directory=None, authserver_url=None, inet=False):
+        from canonical.codehosting import transport
+        try:
+            os.unlink('/home/abentley/log')
+        except:
+            pass
+        log = open('/home/abentley/log', 'w')
+        print >> log, ('*!*!*!* ' + os.environ['BZR_PLUGIN_PATH'])
+        print >> log, plugin.all_plugins()
+        print >> log, 'BZR_HOME=%r' % os.environ.get('BZR_HOME')
+        print >> log, 'HOME=%r' % os.environ.get('HOME')
+        print >> log, '_log_file_name=%r' % (trace._bzr_log_filename,)
+        log.flush()
+        bzrlog = open(trace._bzr_log_filename)
+        log.write(bzrlog.read())
+        log.close()
         if upload_directory is None:
             upload_directory = config.codehosting.branches_root
         if mirror_directory is None:

=== modified file 'lib/canonical/codehosting/__init__.py'
--- lib/canonical/codehosting/__init__.py	2008-01-21 01:51:58 +0000
+++ lib/canonical/codehosting/__init__.py	2008-01-21 05:44:15 +0000
@@ -9,6 +9,7 @@
 
 
 import os.path
+from bzrlib.plugin import set_plugins_path
 from bzrlib.progress import ProgressBarStack
 from bzrlib.ui import SilentUIFactory
 
@@ -59,4 +60,8 @@
 
 def get_bzr_plugins_path():
     """Find the path to the Bazaar plugins for this rocketfuel instance"""
-    return get_rocketfuel_root() + '/bzr-plugins'
+    return get_rocketfuel_root() + '/bzrplugins'
+
+
+os.environ['BZR_PLUGIN_PATH'] = get_bzr_plugins_path()
+set_plugins_path()

=== modified file 'lib/canonical/codehosting/smartserver.py'
--- lib/canonical/codehosting/smartserver.py	2008-01-21 01:51:58 +0000
+++ lib/canonical/codehosting/smartserver.py	2008-01-21 05:44:15 +0000
@@ -4,8 +4,7 @@
 
 __metaclass__ = type
 __all__ = [
-    'ExecOnlySession', 'RestrictedExecOnlySession', 'get_bzr_path',
-    'launch_smart_server']
+    'ExecOnlySession', 'RestrictedExecOnlySession', 'launch_smart_server']
 
 import os
 import urlparse
@@ -17,7 +16,7 @@
 from twisted.python import log
 
 from canonical.config import config
-from canonical.codehosting import get_bzr_path, get_bzr_plugins_path
+from canonical.codehosting import get_bzr_path
 
 
 class ForbiddenCommand(Exception):
@@ -69,8 +68,9 @@
             protocol.write(str(e) + '\r\n')
             protocol.loseConnection()
             raise
+        sorted_environment = sorted(self.environment.items())
         log.msg('Running: %r, %r, %r'
-                % (executable, arguments, self.environment))
+                % (executable, arguments, sorted_environment))
         self._transport = self.reactor.spawnProcess(
             protocol, executable, arguments, env=self.environment)
 
@@ -147,7 +147,6 @@
         % {'python': sys.executable, 'bzr': get_bzr_path()})
 
     environment = dict(os.environ)
-    environment['BZR_PLUGIN_PATH'] = get_bzr_plugins_path()
 
     # Extract the hostname from the supermirror root config.
     hostname = urlparse.urlparse(config.codehosting.supermirror_root)[1]

=== modified file 'lib/canonical/codehosting/tests/test_acceptance.py'
--- lib/canonical/codehosting/tests/test_acceptance.py	2007-12-10 05:18:39 +0000
+++ lib/canonical/codehosting/tests/test_acceptance.py	2008-01-21 05:44:15 +0000
@@ -17,6 +17,7 @@
 from bzrlib.builtins import cmd_branch, cmd_push
 from bzrlib.errors import (
     BzrCommandError, NotBranchError, TransportNotPossible)
+from bzrlib.plugins.loom import branch as loom_branch
 from bzrlib.repofmt.weaverepo import RepositoryFormat7
 from bzrlib.repository import format_registry
 
@@ -508,6 +509,26 @@
             (BzrCommandError, TransportNotPossible),
             self.push, self.local_branch_path, remote_url)
 
+    @deferToThread
+    def test_can_push_loom_branch(self):
+        # We can push and pull a loom branch.
+        tree = self.make_branch_and_tree('loom')
+        tree.lock_write()
+        try:
+            tree.branch.nick = 'bottom-thread'
+            loom_branch.loomify(tree.branch)
+        finally:
+            tree.unlock()
+        loomtree = tree.bzrdir.open_workingtree()
+        loomtree.lock_write()
+        loomtree.branch.new_thread('bottom-thread')
+        loomtree.commit('this is a commit', rev_id='commit-1')
+        loomtree.unlock()
+        loomtree.branch.record_loom('sample loom')
+        remote_url = self.getTransportURL('~testuser/+junk/loom')
+        self.push('loom', remote_url)
+        self.assertBranchesMatch('loom', remote_url)
+
 
 class SmartserverTests(SSHTestCase):
     """Acceptance tests for the codehosting smartserver."""

=== modified file 'lib/canonical/codehosting/tests/test_lpserve.py'
--- lib/canonical/codehosting/tests/test_lpserve.py	2008-01-21 01:51:58 +0000
+++ lib/canonical/codehosting/tests/test_lpserve.py	2008-01-21 05:44:15 +0000
@@ -14,7 +14,7 @@
 
 import bzrlib
 from bzrlib.commands import get_cmd_object
-from bzrlib.plugin import set_plugins_path
+from bzrlib.plugins import lpserve
 from bzrlib.smart import medium
 from bzrlib.tests import TestCaseInTempDir
 from bzrlib.transport import get_transport, remote
@@ -24,15 +24,12 @@
 
 from canonical.tests.test_twisted import TwistedTestCase
 
-from canonical.codehosting import plugins, get_bzr_plugins_path
+from canonical.codehosting import plugins
 from canonical.codehosting.tests.helpers import deferToThread
 from canonical.config import config
 from canonical.codehosting.tests.servers import Authserver
 
 from canonical.testing import TwistedLayer
-os.environ['BZR_PLUGIN_PATH'] = get_bzr_plugins_path()
-set_plugins_path()
-from bzrlib.plugins import lpserve
 
 
 ROCKETFUEL_ROOT = os.path.dirname(

